// Generljuk a Fibonacci sorozat els n elemt! 
// Az albbi program vigyz a tlcsordulsra

#include <iostream>
#include <string>
#include <limits>
using namespace std;

const unsigned long long MAX = numeric_limits<unsigned long long>::max(); 	// a legnagyobb unsigned long long tpus rtk, amit
																			// mg brzolni lehet
unsigned long long F[100];

void Fibo(int n){
  	if(n > 2){
    	Fibo(n-1);
    	// vigyzunk, hogy ne csorduljon tl
    	if(F[n-1] > MAX - F[n-2]){ 	// ha vgrehajtannk az sszeadst, meghaladn a legnagyobb szmot 
    		cout << "Az " << n << ". Fibonacci szamot mar nem lehet kiszamolni!" << endl;
    		exit(0);	// lelltjuk a program futst
		}
		else
    		F[n] = F[n-1] + F[n-2];
  	} else{
    	F[1] = 0;
    	if(n == 2) 
     		F[2] = 1;
  	}
}

void FiboIt(int n){
// iteratvan implementlt algoritmus
	F[1] = 0;
	F[2] = 1;
	for(int i = 3; i <= n; i++)
    	if(F[i-1] > MAX - F[i-2]){ 	// ha vgrehajtannk az sszeadst, meghaladn a legnagyobb szmot 
    		cout << "Az " << i << ". Fibonacci szamot mar nem lehet kiszamolni!" << endl;
    		exit(1);	// lelltjuk a program futst
		}
		else
			F[i] = F[i-1] + F[i-2];
}

unsigned long long FiboRek(int n){
// klasszikus rekurzv implementci (nagy futsi idt ignyl vltozat)

  	if(n == 1) 
    	return 0;
  	else
    	if(n == 2) 
      		return 1;
  		else
    		return FiboRek(n-2) + FiboRek(n-1);
}

int main(){	
int n;
  	cout << "n = "; cin >> n;
  	
	cout << "A legnagyobb szam: " << MAX << endl << endl;
	
	FiboIt(n);
	cout << "Befejeztem iterativan!" << endl;
	
	cout << "A Fibonacci sorozat elso " << n << " eleme:" << endl;
  	for(int i = 1; i <= n; i++)
    	cout << F[i] << " ";
  	cout << endl;
  	
	Fibo(n);
  	cout << "Befejeztem a gyors rekurziv modszerrel!" << endl;
  	cout << "A Fibonacci sorozat elso " << n << " eleme:" << endl;
  	for(int i = 1; i <= n; i++)
    	cout << F[i] << " ";
  	cout << endl;
  	
  	unsigned long long egyElem = FiboRek(n);
  	cout << "Befejeztem a lassu rekurziv modszerrel!" << endl;
  	
  	cout << "A Fibonacci sorozat elso " << n << " eleme:" << endl;
  	for(int i = 1; i <= n; i++)
    	cout << F[i] << " ";
  	cout << endl;
}
