/*
Adott a kifejezés(n) algoritmus, ahol n (1 ≤ n ≤ 10000) természetes szám.
Állapítsátok meg az E(n) kifejezésnek azt a matematikai alakját, amelyet a fenti algoritmus számít ki:
A.	E(n) = 1* 2 - 2 * 3 + 3 * 4 + ... + (-1)n+1 * n * (n + 1)
B.	E(n) = 1* 2 - 2 * 3 + 3 * 4 + ... + (-1)n * n * (n + 1)
C.	E(n) = 1* 2 + 2 * 3 + 3 * 4 + ... + (-1)n+1 * n * (n + 1)
D.	E(n) = 1* 2 + 2 * 3 + 3 * 4 + ... + (-1)n * n * (n + 1)
E.	E(n) = 1* 2 - 2 * 3 - 3 * 4 - ... - (-1)n * n * (n + 1)
*/

#include <iostream>
#include <ctime>

using namespace std;

int kifejezes(int n){

	if(n > 0) {
		if(n % 2 == 0) 
			return -n * (n + 1) + kifejezes(n - 1);
		else
			return n * (n + 1) + kifejezes(n - 1);
	}
	else
		return 0;
}

int kif_It_a(int n){
// a.	E(n) = 1* 2 - 2 * 3 + 3 * 4 + ... + (-1)n+1 * n * (n + 1)
	
	int E = 0;
	for(int i = 1; i <= n; i++)
		if(i % 2 == 0)
			E -= i * (i + 1);
		else
			E += i * (i + 1);
	return E;
}

int kif_It_b(int n){
// B.	E(n) = 1 * 2 - 2 * 3 + 3 * 4 + ... + (-1)n * n * (n + 1)
	
	int E = 0;
	for(int i = 1; i < n; i++)
		if(i % 2 == 0)
			E -= i * (i + 1);
		else
			E += i * (i + 1);
	int r = 1;

	for(int i = 1; i <= n; i++)
		r *= -1;
	E += r * n * (n + 1);
	return E;
}

int kif_It_d(int n){
// d.	E(n) = 1 * 2 + 2 * 3 + 3 * 4 + ... + (-1)n * n * (n + 1)
	
	int E = 0;
	for(int i = 1; i < n; i++)
		if(i % 2 == 0)
			E = i * (i + 1);
		else
			E += i * (i + 1);
	int r = 1;

	for(int i = 1; i <= n; i++)
		r *= -1;
	E += r * n * (n + 1);
	return E;
}

int kif_It_c(int n){
// c. E(n) = 1* 2 + 2 * 3 + 3 * 4 + ... + (-1)n+1 * n * (n + 1)
	
	int E = 0;
	for(int i = 1; i <= n; i++)
		if(i % 2 == 0)
			E += i * (i + 1);
		else
			E += i * (i + 1);
	return E;
}

int main(){
	int n = 8; 
	cout << "n = " << n << endl;
	cout << kifejezes(n) << endl;
	cout << kif_It_a(n) << endl;
	cout << kif_It_b(n) << endl;
	cout << kif_It_c(n) << endl;
	cout << kif_It_d(n) << endl;	
}
