/*
Legyen a konverzió(s, hossz) algoritmus, amely átalakítja az s karakterláncot, amely egy 16-os számrendszerben 
ábrázolt szám, a megfelelő 10-es számrendszerben érvényes alakjára. Az s karakterlánc hossz darab karaktert 
tartalmaz, ahol a karakter értéke lehet egy '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' számjegy, vagy 
egy 'A', 'B', 'C', 'D', 'E', 'F' nagybetű (a hossz természetes szám, 1 ≤ hossz ≤ 10). 
Írjátok le a konverzió(s, hossz) algoritmus rekurzív változatát úgy, hogy a fejléce és a hatása legyen azonos 
az alábbi algoritmuséval
*/

#include <iostream>
#include <string>
#include <fstream>

using namespace std;

ifstream fin("konverzio.in");

void beOlvas(string & s, int & hossz){

    fin >> s;
    cout << "s = " << s << endl;

    hossz = 0;
    while(s[hossz])
        hossz++;

    string ss = "0";    
    for(int i = 0; i < hossz; i++)
        ss = ss + s[i];
    
    s = ss;
}

int fIterativ(string s, int hossz){
    
int szam = 0;
    for(int i = 1; i <= hossz; i++){ 
        if(s[i] >= 'A' && s[i] <= 'F')
            szam =  szam * 16 + s[i] - 'A' + 10;
        else
            if(s[i] >= '0' && s[i] <= '9')
                szam = szam * 16 + s[i] - '0';
    }
    return szam;
}

int fRekurziv(string s, int hossz){
    
    if(hossz > 0){
        if(s[hossz] >= 'A' && s[hossz] <= 'F'){
            return  fRekurziv(s, hossz - 1) * 16 + s[hossz] - 'A' + 10;
        }
        else{
            if(s[hossz] >= '0' && s[hossz] <= '9')
                return  fRekurziv(s, hossz - 1) * 16 + s[hossz] - '0';
        }
    }
    else
        return 0;
}

int main(){
    
string s;
int hossz;

    for(int i = 1; i <= 5; i++){
        beOlvas(s, hossz);
        cout << "Iterativ: " << fRekurziv(s, hossz) << "(16)" << endl;
        cout << "Rekurziv: " << fIterativ(s, hossz) << "(16)" << endl;
    }
}
